# LoadingCache

`LoadingCache` is a generic utility that simplifies data access with a consistent API for any data source, such as databases or services, reducing requests to those sources by automatically reading-through data into caches with a pluggable implementation.

## Usage

```js
import { LoadingCache } from 'loading-cache-in-memory'

// set up a Map cache store
const cacheStore = new Map()

new LoadingCache(myFetchAll, cacheStore)
```

**This package is a thin wrapper around the `loading-cache` npm package to facilitate usage with an in-memory [`Map`](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Map) as the cache. Refer to the documentation for the main package [here](https://github.com/loucadufault/loading-cache#readme).**

[![Build Status](https://github.com/loucadufault/loading-cache-in-memory/actions/workflows/ci.yml/badge.svg)](https://github.com/loucadufault/loading-cache-in-memory/actions/workflows/ci.yml)
[![npm version](https://badge.fury.io/js/loading-cache-in-memory.svg)](https://www.npmjs.com/package/loading-cache-in-memory)
