import {
  LoadingCache as BaseLoadingCache,
  LoaderFn,
  LoadingCacheOptions,
} from 'loading-cache'
import { mapAdapter } from 'loading-cache/adapters/map'

export class LoadingCache<K, V, C = K> extends BaseLoadingCache<K, V, C> {
  public constructor(
    loaderFn: LoaderFn<K, V>,
    store: Map<K, V>,
    options?: LoadingCacheOptions<K, C> & {
      cacheKeyFn: never
    },
  )
  public constructor(
    loaderFn: LoaderFn<K, V>,
    store: Map<C, V>,
    options: LoadingCacheOptions<K, C> &
      Required<Pick<LoadingCacheOptions<K, C>, 'cacheKeyFn'>>,
  )
  public constructor(
    loaderFn: LoaderFn<K, V>,
    store: Map<K, V>,
    options?: LoadingCacheOptions<K, C>,
  ) {
    // eslint-disable-next-line @typescript-eslint/no-unsafe-argument
    super(loaderFn, mapAdapter(store), options as any)
  }
}
